// WikkelServo Voerboot project
// Gemaakt door MdG-RC-Electronics "marten77"

#include <VarSpeedServo.h>                                       // Dit is een externe bibliotheek trage servo beweging
#include <EEPROM.h>

#define RCmax      2200                                          // 
#define RCmid      1500          
#define RCmin       800 
#define RCcor        15         
#define TimeOut  260000 

#define Aan 1
#define Uit 0

#define MaxPos1              170                                  // 
#define MinPos1               10                                  //
#define MidPos1      (MaxPos1 - MinPos1) / 2 
#define MaxSpeed1            127 
#define MinSpeed1             10 

#define WikkelServoPin        8
#define RCport1               4                                  // 

VarSpeedServo WikkelServo;                                       //servo om het wikkelen te begeleiden

int RCpulse1;                                                    // dit geeft de variable RCpulse1 een integerwaarde (een geheel getal tussen 0 en ...) in RCread! deze waarden kan vervolgens worden veranderds naar believe
int Address1 = 0;
int Address2 = 1;                                                 // EEProm adres 1 gebruiken we, om de laatste Pos1 op te slaan
int Address3 = 2;                                                 // EEProm adres 2 gebruiken we, om de laatste Richting1 op te slaan

byte Pos1;
byte Speed1;
byte ReadPos1;                                                 // hier maken we een uitlees var. aan voor de servo positie uit te lezen, dan kunnen we dingen starten vanaf een bepaalde servo positie alleen 3 wordt nu gebruikt
byte Richting1;
byte Richting1BackUp;

void setup()
{
  Richting1BackUp = EEPROM.read(Address3);
  if(Richting1BackUp == 0 && EEPROM.read(Address1) == 0)
   { // dit gebeurt maar eenmalig, i.v.m. de eerste opstart!
    EEPROM.write(Address1,MaxPos1);
    EEPROM.write(Address2,MaxPos1); 
    EEPROM.write(Address3,MaxPos1); 
    Richting1 = MaxPos1;}
  else {Richting1 = Richting1BackUp;}
  
  Pos1 = EEPROM.read(Address2);                                 // Start waarde voor servo positie
  ReadPos1 = EEPROM.read(Address2);                             //  
  Speed1 = MinSpeed1;                                           //   

  WikkelServo.attach  (WikkelServoPin);                        //plaats de servo op pin 8 (zie regel 20)
  WikkelServo.write(Pos1);                                     // deze regel zorgt ervoor dat tijdens de start, de servo naar de gewenste positie gaat of blijft op deze postitie en niet centered

  pinMode(RCport1, INPUT_PULLUP);                              //plaats de ontvanger op pin 4 (zie regel 21)                                    // 
  
//Serial.begin(9600);
}

void RCread(){ // hier word de RC input ingelezen
  RCpulse1 = pulseIn(RCport1, HIGH, TimeOut);}                // Leest de ogenblikkelijke puls van de ontvanger

void Hijsen()
  {
   Speed1 = map(RCpulse1, RCmin, RCmid-RCcor, MinSpeed1, MaxSpeed1);
   if(ReadPos1 > MaxPos1-1){Richting1 = MinPos1;}
   else if(ReadPos1 < MinPos1+1){Richting1 = MaxPos1;}
   else{Pos1 = Richting1;} // Pos1 is laatste richting
  }
  
void Vieren()
  {
   Speed1 = map(RCpulse1, RCmid+RCcor, RCmax, MinSpeed1, MaxSpeed1); 
   if(ReadPos1 > MaxPos1-1){Richting1 = MinPos1;}
   else if(ReadPos1 < MinPos1+1){Richting1 = MaxPos1;}
   else{Pos1 = Richting1;} // Pos1 is laatste richting
  }

void loop()
 {
    RCread(); // Ga naar RCread, om de RC input in te lezen.
   
    if(RCpulse1 > RCmin-RCcor && RCpulse1 < RCmax+RCcor)
     {                                                         // Zijn ze binnen een veilige zone, dan voer onderstaande uit:
      if(RCpulse1 >= RCmid-RCcor && RCpulse1 <= RCmid+RCcor)  // Stick in het midden
        {
         Pos1 = ReadPos1; 
         EEPROM.update(Address2, Pos1);
         EEPROM.update(Address3, Richting1);
        }
      else if(RCpulse1 > RCmid+RCcor){Vieren();} // 
      else {Hijsen();}        
     }
    else {Pos1 = MidPos1; Speed1 = MinSpeed1;}
    
    WikkelServo.write(Pos1,Speed1,false);                            // laat de servo naar de variabele 'pos1' gaan            
    ReadPos1 = WikkelServo.read();                                   // lees de positie van de servo

//Serial.print("RCpulse1 = ");                                          // hiermee kan je de pulses meten en tonen als het bord is aangesloten op de seriele monitor.
//Serial.println(RCpulse1); 
//delay(1000);
 }
